﻿#!/bin/bash

tty_to_use="/dev/tty1"

part_uboot=0
part_kernel=1
part_dtb=2
part_rootfs=4

update_utils=$1"/utils"
update_source=$1

systemctl kill player

# clear screen
echo -e '\033[2J' > $tty_to_use
# cursor to 0,0
echo -e '\033[0;0H' > $tty_to_use

echo $update_utils > $tty_to_use
echo $update_source > $tty_to_use

echo "Running update script!!!" > $tty_to_use

if [ -d $update_source ]; then
    echo "Starting update" > $tty_to_use
    echo "DO NOT REMOVE POWER WHILE UPDATE IS IN PROGRESS!" > $tty_to_use

    
    if [ -f $update_source"/u-boot-imx7dsabresd.imx" ]; then
        echo "U-Boot found!!" > $tty_to_use
		echo "Erasing partition $part_uboot!!" > $tty_to_use

        $update_utils/flash_erase /dev/mtd$part_u-boot 0 0
        $update_utils/nandwrite -p /dev/mtd$part_u-boot -p $update_source"/u-boot-imx7dsabresd.imx"
    fi

    if [ -f $update_source"/zImage" ]; then
        echo "zImage found!!" > $tty_to_use
        echo "Erasing partition $part_kernel!!" > $tty_to_use

        $update_utils/flash_erase /dev/mtd$part_kernel 0 0
        $update_utils/nandwrite -p /dev/mtd$part_kernel -p $update_source"/zImage"
    fi

    if [ -f $update_source"/imx7d-et1100.dtb" ]; then
        echo "DTB found!!" > $tty_to_use
        echo "Erasing partition $part_dtb!!" > $tty_to_use

        $update_utils/flash_erase /dev/mtd$part_dtb 0 0
        $update_utils/nandwrite -p /dev/mtd$part_dtb -p $update_source"/imx7d-et1100.dtb"
    fi

	if [ -d /home/player/animations ]; then
		echo "Make backup!!" > $tty_to_use
		
		mkdir /home/player/backup
		mv /home/player/animations/*  /home/player/backup
		rm /home/player/animations/*
	fi
	
    if [ -f $update_source"/rootfs.tar.bz2" ]; then
        echo "Rootfs found!!" > $tty_to_use
		echo "Unpacking filesytem!!" > $tty_to_use
		
        mount -t ubifs ubi0:rootfs /mnt
		# output to stdout NOT redirect the display
        /bin/tar -xjvf ./update/rootfs.tar.bz2 -C /mnt
        sync
    fi
	
	if [ -d /home/player/backup ]; then
		rm -f /home/player/animations/*.*
		mv /home/player/backup/*  /home/player/animations/
		rm -rf /home/player/backup
		sync
	fi
	
	if [ -d /home/player ]; then
		echo "Configure avahi service !!" > $tty_to_use
		/home/player/setup_player.sh
		echo "Change owner of all files in player derectory !!" > $tty_to_use
		chown -R player:player /home/player > $tty_to_use
		sync
	fi
fi

/home/root/update/utils/reset.sh &

echo "Update script complete!!!" > $tty_to_use
echo "Update script complete!!!"

