#!/bin/bash

# Hide cursor
echo -e '\033[?17;0;0c' > /dev/tty1
# Disable screensaver
echo -e '\033[9;0]' > /dev/tty1


function show_png ()
{
	timeout_us=$1
	image_to_show="$2"
   
	# first, run process in background
	(exec sh -c "gst-launch-1.0 -q -f filesrc location=$image_to_show ! pngdec ! videoconvert ! imagefreeze ! fbdevsink device=/dev/fb0 > /dev/null") &

    usleep $timeout_us
	
	killall gst-launch-1.0 > /dev/null
}

function show_jpg ()
{
	timeout_us=$1
	image_to_show="$2"
   
	# first, run process in background
	(exec sh -c "gst-launch-1.0 -q -f filesrc location=$image_to_show ! jpgdec ! videoconvert ! imagefreeze ! fbdevsink device=/dev/fb0 > /dev/null") &

    usleep $timeout_us
	
	killall gst-launch-1.0 > /dev/null
}


function show_mp4 ()
{
	timeout_us=$1
	image_to_show="$2"
   
	# first, run process in background
	(exec sh -c "gst-launch-1.0 -q -f filesrc location=$image_to_show ! pngdec ! videoconvert ! imagefreeze ! fbdevsink device=/dev/fb0 > /dev/null") &

    usleep $timeout_us
	
	killall gst-launch-1.0 
}


cd /home/player/
for((;;))
do
	if [ -f ./animations/nxplay.ini ]; then
		while IFS=, read -r number time_ms file_name; do
			# process the fields
  			# if the line has less than three fields, the missing fields will be set to an empty string
  			# if the line has more than three fields, `field3` will get all the values, including the third field plus the delimiter(s)
  			echo 0 > /sys/class/graphics/fb0/blank
			echo $number $time_ms $file_name

			file_base_name=$(basename -- "$file_name")
			file_extension="${file_base_name##*.}"
			time_us=$((time_ms*1000))
			#echo $file_base_name  > /dev/tty1
			#echo $file_extension  > /dev/tty1
			
			
#			if [ -f ./animations/"$file_name" ]; then
				case "$file_extension" in
					"3gp"*)
					;&
					"mp4"*)
						gst-launch-1.0 filesrc location=./animations/"$file_name" ! qtdemux ! h264parse ! avdec_h264 ! videoconvert ! fbdevsink device=/dev/fb0
					;;
					
					"png"*)
						show_png $time_us ./animations/"$file_name"
					;;
					"jpg"*)
						show_jpg $time_us ./animations/"$file_name"
					;;
					
					*)
						echo "unsuported format for file $file_name"
					;;
				esac
#			else
#				echo "$file_name" not found
#			fi
		done < ./animations/nxplay.ini
	else
		for file in ./animations/*
		do
			echo 0 > /sys/class/graphics/fb0/blank
			if [ -f ./overlay/overlay.png ]
			then
				gst-launch-1.0 filesrc location="$file" ! qtdemux ! h264parse ! avdec_h264 ! videoconvert ! gdkpixbufoverlay location=./overlay/overlay.png alpha=1 ! fbdevsink device=/dev/fb0
			else
				gst-launch-1.0 filesrc location="$file" ! qtdemux ! h264parse ! avdec_h264 ! videoconvert ! fbdevsink device=/dev/fb0
			fi
		done
	fi
done
