#!/bin/bash
#modprobe usbcore autosuspend=-1
#modprobe g_ether
#ifconfig usb0 192.168.100.5

hostname et-1100

modprobe libcomposite

while [ ! -d "/sys/kernel/config/usb_gadget/" ] ;
do
     sleep 2
done


if [ -d "/sys/kernel/config/usb_gadget/" ]; then

	
	cd /sys/kernel/config/usb_gadget/
	mkdir g && cd g

	echo 0x065A > idVendor  # Opto Electronics
	echo 0x9001 > idProduct # Multifunction Composite Gadget
	echo 0x0100 > bcdDevice # v1.0.0
	echo 0x0200 > bcdUSB    # USB 2.0

# This is a Multi-interface Function Device
	echo 0xEF > bDeviceClass

	echo 0x02 > bDeviceSubClass
	echo 0x01 > bDeviceProtocol

	echo 1       > os_desc/use

	echo 0xcd    > os_desc/b_vendor_code

	echo MSFT100 > os_desc/qw_sign

	mkdir -p strings/0x409

#	cat /sys/fsl_otp_test/HW_OCOTP_TESTER0 > strings/0x409/serialnumber
	echo ""			> strings/0x409/serialnumber
	echo "opticon"          > strings/0x409/manufacturer
	echo "et1100"           > strings/0x409/product

	mkdir -p functions/acm.usb0    # serial
	mkdir -p functions/rndis.usb0  # network
	mkdir -p functions/mtp.usb0    # Google Media transfer protocol.

	echo "RNDIS"   > functions/rndis.usb0/os_desc/interface.rndis/compatible_id
	echo "5162001" > functions/rndis.usb0/os_desc/interface.rndis/sub_compatible_id

	mkdir -p configs/c.1
	ln -s configs/c.1 os_desc

	echo 500 > configs/c.1/MaxPower
	ln -s functions/rndis.usb0 configs/c.1/
	ln -s functions/acm.usb0   configs/c.1/
 	ln -s functions/mtp.usb0   configs/c.1/

	udevadm settle -t 5 || :
	ls /sys/class/udc/ > UDC

# confure rndis interface
	/sbin/ifup usb0

# make avahi work
#	echo 10 > proc/sys/net/ipv4/igmp_max_memberships
#	systemctl restart avahi-daemon


# start mtp-server
	chown player /dev/mtp_usb
#	/usr/bin/mtp-server &
fi
